package org.amse.byBedrosova.go.model;

import org.amse.byBedrosova.go.exception.GoException;

/**
 * ,       
 *          
 * ,    ,     
 *  
 */
public class BoardPoint {
	private int myVertical;
	private int myHorizontal;
	private boolean myIsValid;

	/**
	 * 
	 *     
	 *       ,  
	 *  
	 * @param board ,    
	 * @param vertical   
	 * @param horizontal   
	 */
	public BoardPoint(IBoard board, int vertical, int horizontal) {
		myVertical = vertical;
		myHorizontal = horizontal;
		myIsValid = (vertical >= 0 && 
					 vertical < board.getSize() &&
					 horizontal >= 0 && 
					 horizontal < board.getSize());
	}

	/**
	 * 
	 *   ,     
	 *  
	 */
	public BoardPoint() {
		myIsValid = false;
	}

	/**
	 *    
	 * @return true,     [0, boardSize),  
	 *       ,  - false 
	 */
	public boolean isValid() {
		return myIsValid;
	}

	/**
	 *      
	 *    -  GoException
	 * @return   
	 */
	public int getVertical() {
		if (!myIsValid) {
			throw new GoException ("Can not get vertical coordinate of invalid BoardPoint");
		}
		return myVertical;
	}

	/**
	 *      
	 *    -  GoException
	 * @return   
	 */
	public int getHorizontal() {
		if (!myIsValid) {
			throw new GoException ("Can not get vertical coordinate of invalid BoardPoint");
		}
		return myHorizontal;
	}
}
