package org.amse.byBedrosova.go.model;

import javax.swing.ImageIcon;

import org.amse.byBedrosova.go.exception.GoException;
import org.amse.byBedrosova.go.view.View;

/**
 * ,        
 */
public enum GoColor {
	BLACK {
		private ImageIcon myIcon = View.loadIcon("/icons/black.png");
		private ImageIcon myTransparentIcon = View.loadIcon("/icons/black_tr.png");
		private ImageIcon myCrossedIcon = View.loadIcon("/icons/black_cr.png");

		public GoColor getOppositeColor () {
			return GoColor.WHITE;
		}
		public ImageIcon getIcon () {
			return myIcon;
		}
		public ImageIcon getTransparentIcon () {
			return myTransparentIcon;
		}
		public ImageIcon getCrossedIcon () {
			return myCrossedIcon;
		}
	},
	WHITE {
		private ImageIcon myIcon = View.loadIcon("/icons/white.png");
		private ImageIcon myTransparentIcon = View.loadIcon("/icons/white_tr.png");
		private ImageIcon myCrossedIcon = View.loadIcon("/icons/white_cr.png");

		public GoColor getOppositeColor () {
			return GoColor.BLACK;
		}
		public ImageIcon getIcon () {
			return myIcon;
		}
		public ImageIcon getTransparentIcon () {
			return myTransparentIcon;
		}
		public ImageIcon getCrossedIcon () {
			return myCrossedIcon;
		}
	},
	RED {
		private ImageIcon myIcon = View.loadIcon("/icons/red.png");
		public GoColor getOppositeColor () {
			throw new GoException ("Opposite color for red color does not exist");
		}
		public ImageIcon getIcon () {
			return myIcon;
		}
		public ImageIcon getTransparentIcon () {
			throw new GoException ("Transparent icon for red color does not exist");
		}
		public ImageIcon getCrossedIcon () {
			throw new GoException ("Crossed icon for red color does not exist");
		}
	};
	
	/**
	 * ,    
	 * @return    ,    
	 */
	abstract public GoColor getOppositeColor();
	
	/**
	 * ,       
	 * @return   
	 */
	abstract public ImageIcon getIcon ();
	
	/**
	 * ,       
	 * @return   
	 */
	abstract public ImageIcon getTransparentIcon ();

	/**
	 * ,       
	 * @return   
	 */
	abstract public ImageIcon getCrossedIcon ();
}
