package org.amse.byBedrosova.go.model.impl;

import org.amse.byBedrosova.go.exception.GoException;
import org.amse.byBedrosova.go.model.*;

/**
 * ,       
 */
class Board implements IBoard {
	
	private IStone [][] myBoard;
	
//-------------------------------------------------------------------------
	public Board (int size) {
		myBoard = new Stone [size][size];
	}	
//	-------------------------------------------------------------------------
	public int getSize () {
		return myBoard.length;
	}	
//	-------------------------------------------------------------------------
	/*public boolean canRemoveGroup (int vertical, int horizontal, int color) {
		if (myBoard [vertical][horizontal] == null) {
			return false;
		}
		if (myBoard [vertical][horizontal].getColor() != color) {
			return false;
		}
		IGroup group = new SimpleGroup (this, myBoard [vertical][horizontal]);
		return group.isSurrounded();		
	}*/	
//	-------------------------------------------------------------------------
	/*public void removeGroup (int vertical, int horizontal) {
		IGroup group = new SimpleGroup (this, myBoard [vertical][horizontal]);
		group.remove ();
	}*/	
//	-------------------------------------------------------------------------
	public IGroup collectGroup (IStone stone) {
		if (myBoard [stone.getVertical()][stone.getHorizontal()] == null) {
			return null;
		}
		if (!(new BoardPoint (this, stone.getVertical(), stone.getHorizontal()).isValid())) {
			return null;
		}		
		return new SimpleGroup (this, stone);		
	}	
//	-------------------------------------------------------------------------
	public IGroup collectGroup (int vertical, int horizontal, GoColor color) {
		if (myBoard [vertical][horizontal] != null) {
			return null;
		}		
		if (!(new BoardPoint (this, vertical, horizontal).isValid())) {
			return null;
		}		
		return new GroupWithFakeStone (this, vertical, horizontal, color);
	}	
//	-------------------------------------------------------------------------
	public boolean isGroupSurrounded (IGroup group) {
		if (group == null) {
			throw new GoException ("Group specified by null value");
		}
		return group.isSurrounded();
	}		
//	-------------------------------------------------------------------------
	public boolean isGroupSurrounded (IGroup group, int vertical, int horizontal) {
		if (group == null) {
			throw new GoException ("Group specified by null value");
		}
		return group.isSurrounded(vertical, horizontal);
	}	
//	-------------------------------------------------------------------------
	public void removeGroup (IGroup group) {
		if (group == null) {
			throw new GoException ("Group specified by null value");
		}
		group.remove();
	}
//	-------------------------------------------------------------------------
	public void removeStone (IStone stone) {
		if (stone == null) {
			throw new GoException ("Stone specified by null value");			
		}
		myBoard [stone.getVertical()][stone.getHorizontal()] = null;
	}	
//	-------------------------------------------------------------------------
	public void setStone (int vertical, int horizontal, GoColor color) {
		if (getStone (vertical, horizontal) != null) {
			throw new GoException ("Stone already stands");			
		}
		myBoard [vertical][horizontal] = new Stone (vertical, horizontal, color);
	}	
//	-------------------------------------------------------------------------
	public IStone getStone (int vertical, int horizontal) {
		if (!((new BoardPoint (this, vertical, horizontal).isValid ()))) {
			return null;
		}
		return myBoard [vertical][horizontal];
	}
}
