package org.amse.byBedrosova.go.model.impl;

import java.util.*;
import org.amse.byBedrosova.go.model.*;

/**
 * ,       
 */
abstract class Group implements IGroup {

	private IBoard myBoard;
	private Set<IStone> myStones = new HashSet<IStone>();	

//	-------------------------------------------------------------------------	
	public void setBoard (IBoard board) {
		myBoard = board;
	}
//	-------------------------------------------------------------------------	
	public IBoard getBoard () {
		return myBoard;
	}
//	-------------------------------------------------------------------------
	private void callCollect (int vertical, int horizontal, GoColor color) {
		if (myBoard.getStone(vertical, horizontal) != null) {
			if (myBoard.getStone(vertical, horizontal).getColor() == color) {
				collect (myBoard.getStone(vertical, horizontal));
			}
		}		
	}
	
	public void collect (IStone stone) {
		if (myStones.contains(stone)) {
			return;
		}
		
		myStones.add(stone);
		
		int vertical = stone.getVertical(),
		    horizontal = stone.getHorizontal();
		GoColor color = stone.getColor();
		
		callCollect (vertical - 1, horizontal    , color);
		callCollect (vertical    , horizontal + 1, color);
		callCollect (vertical + 1, horizontal    , color);
		callCollect (vertical    , horizontal - 1, color);
	}	
//	-------------------------------------------------------------------------	
	protected abstract boolean isEmpty (int vertical, int horizontal);	

	public boolean isSurrounded () {
		for (Iterator it = myStones.iterator(); it.hasNext();) {

			IStone tmp = (Stone)it.next();

			if (((tmp.getVertical() > 0)                       && (isEmpty (tmp.getVertical() - 1, tmp.getHorizontal()    ))) || 
				((tmp.getHorizontal() < myBoard.getSize() - 1) && (isEmpty (tmp.getVertical(),     tmp.getHorizontal() + 1))) ||
				((tmp.getVertical() < myBoard.getSize() - 1)   && (isEmpty (tmp.getVertical() + 1, tmp.getHorizontal()    ))) || 
				((tmp.getHorizontal() > 0)                     && (isEmpty (tmp.getVertical(),     tmp.getHorizontal() - 1)))  ) {
					return false;
			}
		}
	
		return true;
	}
//	-------------------------------------------------------------------------
	public boolean isSurrounded (int vertical, int horizontal) {
		for (Iterator it = myStones.iterator(); it.hasNext();) {

			IStone tmp = (Stone)it.next();

			if (((tmp.getVertical() > 0)                      && 
				  isEmpty (tmp.getVertical() - 1, tmp.getHorizontal()) && 
				  ((tmp.getVertical() - 1 != vertical) || (tmp.getHorizontal() != horizontal))) || 
				((tmp.getHorizontal() < myBoard.getSize() - 1) && 
				  isEmpty (tmp.getVertical(), tmp.getHorizontal() + 1) && 
				  ((tmp.getVertical() != vertical) || (tmp.getHorizontal() + 1 != horizontal))) ||
				((tmp.getVertical() < myBoard.getSize() - 1) && 
				  isEmpty (tmp.getVertical() + 1, tmp.getHorizontal()) && 
				  ((tmp.getVertical() + 1 != vertical) || (tmp.getHorizontal() != horizontal))) || 
				((tmp.getHorizontal() > 0) && 
				  isEmpty (tmp.getVertical(), tmp.getHorizontal() - 1) && 
				  ((tmp.getVertical() != vertical) || (tmp.getHorizontal() - 1 != horizontal)))) {
					return false;
			}
		}		
		return true;
	}	
//	-------------------------------------------------------------------------
	public void remove () {
		for (Iterator i = myStones.iterator(); i.hasNext();) {
			IStone tmp = (IStone)i.next();
			myBoard.removeStone(tmp);
		}
	}
//	-------------------------------------------------------------------------
	public Set<IStone> stones() {
		return Collections.unmodifiableSet(myStones);		
	}
//	-------------------------------------------------------------------------
	public int getSize () {
		return myStones.size();
	}
//	-------------------------------------------------------------------------	
	/*public GoColor getColor () {
		return myStones.iterator().next().getColor();
	}*/
}
