package org.amse.byBedrosova.go.model.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.amse.byBedrosova.go.model.*;

/**
 * ,          
 */
class RealMoveRecord  implements IMoveRecord {
	private IStone myStone;
	private List<IStone> myKilled;
	private boolean myPassed;
	
	public RealMoveRecord (IStone stone, List<IStone> killed) {
		myStone = stone;
		myKilled = new ArrayList<IStone> (killed);
		myPassed = false;
	}

	public IStone getStone () {
		return (new Stone(myStone.getVertical(), myStone.getHorizontal(), myStone.getColor()));
	}
	
	public GoColor getColor () {
		return myStone.getColor();
	}
	
	public List<IStone> getKilled () {
		return Collections.unmodifiableList(myKilled);
	}
	
	public boolean isPass() {
		return myPassed;
	}
}
