package org.amse.byBedrosova.go.view;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

@SuppressWarnings("serial")
public class GoLoadGameAction extends AbstractAction {
	private View myView;
	
	public GoLoadGameAction (View view) {
		super ("Load game...", View.loadIcon ("/icons/load.gif"));
		myView = view;
	}

	public void actionPerformed(ActionEvent e) {		
		myView.getPanel().showCursor(false);
		if (myView.getGame().modified()) {
			switch (JOptionPane.showConfirmDialog (myView, "Do you want to save current game?",
					"Load game",
					JOptionPane.YES_NO_CANCEL_OPTION)) {
			
			case JOptionPane.YES_OPTION:
				if (myView.saveDialog()) {
					myView.loadGameDialog();
				}
				break;
				
			case JOptionPane.NO_OPTION:
				myView.loadGameDialog();
				break;
				
			default:
				break;
			}	
		} else {
			myView.loadGameDialog();
		}
		myView.getPanel().showCursor(true);
		myView.updateAll();
	}	
}
