package org.amse.byBedrosova.go.view;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

@SuppressWarnings("serial")
public class GoNewGameAction extends AbstractAction {
	private View myView;
	
	public GoNewGameAction (View view) {
		super ("New Game", View.loadIcon ("/icons/new.gif"));
		myView = view;
	}
	
	public void actionPerformed(ActionEvent e) {
		myView.getPanel().showCursor(false);
		if (myView.getGame().modified()) {
			switch (JOptionPane.showConfirmDialog (myView, "Do you want to save current game?",
					"Load game",
					JOptionPane.YES_NO_CANCEL_OPTION)) {
			
			case JOptionPane.YES_OPTION:
				if (myView.saveDialog()) {
					myView.getGame().clear();		
					break;
				} else {
					break;
				}					
			case JOptionPane.NO_OPTION:
				myView.getGame().clear();		
				break;
				
			default:
				break;
			}	
		} else {
			myView.getGame().clear();		
		}
		myView.getPanel().showCursor(true);
		myView.updateAll();
	}		
}		
