package org.amse.byBedrosova.go.view;

import java.awt.event.*;

import javax.swing.*;

import org.amse.byBedrosova.go.exception.GoException;

@SuppressWarnings("serial")
public class GoPassAction extends AbstractAction {
	
	private View myView;
	
	public GoPassAction(View view) {
		super("Pass", View.loadIcon("/icons/pass.gif"));
		myView = view;
	}

	public void actionPerformed(ActionEvent e) {
		if (!myView.getGame().canPass()) {
			throw new GoException ("Can not pass");
		}
		myView.getGame().pass();
		if (myView.getGame().isGameOver ()) {
			myView.gameOverDialog ();
		}
		myView.updateAll();
	}
	
	public boolean isEnabled() {
		return myView.getGame().canPass();
	}
}
