package org.amse.byBedrosova.go.view;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

@SuppressWarnings("serial")
public class GoUndoAction extends AbstractAction {
	private View myView;
	
	public GoUndoAction (View view) {
		super ("Undo move", View.loadIcon ("/icons/undo.gif"));
		myView = view;
	}

	public void actionPerformed(ActionEvent e) {
		if (!myView.getGame().canUndoMove()) {
			return;
		}
		myView.getGame().undoMove();
		myView.updateAll();			
	}
	
	public boolean isEnabled () {
		return myView.getGame().canUndoMove();
	}
}
