package org.amse.byBedrosova.tests;

import junit.framework.TestCase;

import org.amse.byBedrosova.go.io.*;
import org.amse.byBedrosova.go.model.*;
import org.amse.byBedrosova.go.model.impl.ModelFactory;
import org.amse.byBedrosova.go.exception.*;
import org.amse.byBedrosova.go.view.View;

public class ReaderTests extends TestCase {
	private static final String myPath = "testing/";
	
/*no file*/
	public void test0 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test0.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("No file not catched");
	}
/*empty file*/
	public void test1 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test1.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("Empty file not catched");
	}
/*file with different contension, but same extension */
	public void test2 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test2.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with different contension not catched");
	}
/*file with different contension and different extension */
	public void test3 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test3.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with different contension not catched");
	}
/*file with illegal header tag*/
	public void test4 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test4.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with wrong encoding and XML version info not catched");
	}
/*file with illegal header tag*/
	public void test5 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test5.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with wrong encoding and XML version info not catched");
	}
/*file with illegal header tag*/
	public void test6 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test6.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with wrong encoding and XML version info not catched");
	}
/*file with illegal header tag*/
	public void test7 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test7.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with wrong encoding and XML version info not catched");
	}
/*file with illegal tag name*/
	public void test8 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test8.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with wrong tag name not catched");
	}
/*file with several same attributes*/
	public void test9 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test9.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with duplicate attributes not catched");
	}
/*file with no attribute*/
	public void test10 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test10.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with no attribute not catched");
	}
/*file with illegal attribute value*/
	public void test11 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test11.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with illegal attribute not catched");
	}
/*file with illegal attribute value*/
	public void test12 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test12.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with illegal attribute not catched");
	}
/*file with not closed tag*/
	public void test13 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test13.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with not closed tag");
	}
/*file with not closed tag*/
	public void test14 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test14.go");				
		} catch (GoException ex) {
			return;
		}
		
		fail ("File with not closed tag");
	}
/*good file*/
	public void test15 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test15.go");				
		} catch (GoException ex) {
			fail ("File was good");
		}		
	}
/*tags shuffled*/
	public void test16 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test16.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with shuffled tags");
	}		
/*tags shuffled*/
	public void test17 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test17.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with shuffled tags");
	}		
/*wrong tag*/
	public void test18 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test18.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with wrong tag (without closing)");
	}		
/*only stone tag*/
	public void test19 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test19.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File missing tags");
	}		
/*odd tag*/
	public void test20 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test20.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with odd sub tag");
	}		
/*attributes missing*/
	public void test21 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test21.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File without some attrubutes");
	}		
/*wrong attribute*/
	public void test22 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test22.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with wrong attrubute");
	}		
/*wrong attribute*/
	public void test23 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test23.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with wrong attrubute");
	}		
/*no game tag*/
	public void test24 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test24.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with no <game> tag");
	}		
/*not closed game tag*/
	public void test25 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test25.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with not closed <game> tag");
	}		
/*two game tags*/
	public void test26 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test26.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with two game tags");
	}		
/*file with some moves lost*/
	public void test27 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test27.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");
	}		
/*file with some moves lost*/
	public void test28 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test28.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");
	}		
/*file with some moves duplicated*/
	public void test29 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test29.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");
	}		
/*file with early closed tag*/
	public void test30 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test30.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");
	}		

	public void test31 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test31.go");				
		} catch (GoException ex) {
			fail ("Good file not processed");
		}		
		
		IGame tmpGame = gf.newGame(19);
		tmpGame.doMove(0, 1);
		tmpGame.doMove(1, 1);
		tmpGame.doMove(1, 0);
		tmpGame.doMove(2, 0);
		tmpGame.doMove(1, 2);
		tmpGame.doMove(2, 2);
		tmpGame.doMove(0, 18);
		tmpGame.doMove(3, 1);
		tmpGame.doMove(2, 1);
		tmpGame.doMove(1, 3);
		
		for (int i = 0; i < game.getBoard().getSize(); ++i) {
			for (int j = 0; j < game.getBoard().getSize(); ++j) {
				if (game.getBoard().getStone(i, j) == null) {
					if (tmpGame.getBoard().getStone(i, j) != null) {
						fail ("Big test failed");
					}
				} else {
					assertTrue("Big test failed", game.getBoard().getStone(i, j).equals(tmpGame.getBoard().getStone(i, j)));
				}
			}
		}
	}		
/*file with wrong color attribute value*/
	public void test32 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test32.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");	
	}
/*file missing color attribute*/
	public void test33 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test33.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");	
	}
/*file missing color attribute value*/
	public void test34 () {
		ModelFactory gf = new ModelFactory ();
		IGame game = gf.newGame(19);
		
		try {
			(new GoReader (game)).loadGame(myPath + "test34.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");	
	}
/*no readme file*/
	public void test35 () {
		View view = new View ();
		view.setVisible(false);
		try {
			(new GoReader (view)).loadAbout(myPath + "test35");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");		
	}
/*settings file without attribute*/
	public void test36 () {
		View view = new View ();
		view.setVisible(false);
		try {
			(new GoReader (view)).loadSettings(myPath + "test36");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");		
	}
/*wrong readme file*/
	public void test37 () {
		View view = new View ();
		view.setVisible(false);
		try {
			(new GoReader (view)).loadAbout(myPath + "test37.go");				
		} catch (GoException ex) {
			return;
		}		
		fail ("File with missed moves");		
	}
}
